<?php
/**
 * Electromix Theme Customizer.
 *
 * @package Electromix 
 */

 if ( ! class_exists( 'Electromix_Customizer' ) ) {

	/**
	 * Customizer Loader
	 *
	 * @since 1.0.0
	 */
	class Electromix_Customizer {

		/**
		 * Instance
		 *
		 * @access private
		 * @var object
		 */
		private static $instance;

		/**
		 * Initiator
		 */
		public static function get_instance() {
			if ( ! isset( self::$instance ) ) {
				self::$instance = new self;
			}
			return self::$instance;
		}

		/**
		 * Constructor
		 */
		public function __construct() {
			/**
			 * Customizer
			 */
			add_action( 'admin_enqueue_scripts',array( $this, 'electromix_admin_script' ) ); 
			add_action( 'customize_preview_init',array( $this, 'electromix_customize_preview_js' ) );
			add_action( 'customize_register',    array( $this, 'electromix_customizer_register' ) );
			add_action( 'after_setup_theme',     array( $this, 'electromix_customizer_settings' ) );
		}
		
		/**
		 * Add postMessage support for site title and description for the Theme Customizer.
		 *
		 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
		 */
		function electromix_customizer_register( $wp_customize ) {
			
			$wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
			$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
			$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
			$wp_customize->get_setting( 'background_color' )->transport = 'postMessage';
			$wp_customize->get_setting('custom_logo')->transport = 'refresh';

			$wp_customize->register_control_type( 'Electromix_Control_Sortable' );
			/**
			 * Helper files
			 */
			require ELECTROMIX_PARENT_INC_DIR . '/customizer/customizer-controls.php';
			require ELECTROMIX_PARENT_INC_DIR . '/customizer/sanitization.php';
		}
		
		
		/**
		 * Admin Script
		 */
		function electromix_admin_script() {
			wp_enqueue_style('electromix-admin-notice', get_template_directory_uri() . '/inc/customizer/assets/css/customizer-notify.css');
			wp_enqueue_script( 'electromix-customizer-section-script', ELECTROMIX_PARENT_INC_URI . '/customizer/assets/js/customizer-section.js', array( 'jquery' ), '', true );
			wp_localize_script( 'electromix-admin-script', 'electromix_ajax_object',
				array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
			);
		}
		
		/**
		 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
		 */
		function electromix_customize_preview_js() {
			wp_enqueue_script( 'electromix-customizer', ELECTROMIX_PARENT_INC_URI . '/customizer/assets/js/customizer-preview.js', array( 'customize-preview' ), '20151215', true );
		}

		// Include customizer customizer settings.
			
		function electromix_customizer_settings() {
			require ELECTROMIX_PARENT_INC_DIR . '/customizer/customizer-options/electromix-header.php';
			require ELECTROMIX_PARENT_INC_DIR . '/customizer/customizer-options/electromix-footer.php';
			require ELECTROMIX_PARENT_INC_DIR . '/customizer/customizer-options/electromix-blog.php';
			require ELECTROMIX_PARENT_INC_DIR . '/customizer/customizer-options/electromix-general.php';
			require ELECTROMIX_PARENT_INC_DIR . '/customizer/customizer-options/electromix-pro.php';
		}

	}
}// End if().

/**
 *  Kicking this off by calling 'get_instance()' method
 */
Electromix_Customizer::get_instance();